/*! riset3v: define types, type modifier and compiler specific macros. */
/*  Copyright (C) [2018-3] Akinori Furuta <afuruta@m7.dion.ne.jp>.           */
/* All rights reserved.                                                      */
/*                                                                           */
/* Redistribution and use in source and binary forms, with or without        */
/* modification, are permitted provided that the following conditions        */
/* are met:                                                                  */
/*                                                                           */
/* 1. Redistributions of source code must retain the above copyright         */
/*    notice, this list of conditions and the following disclaimer.          */
/* 2. Redistributions in binary form must reproduce the above copyright      */
/*    notice, this list of conditions and the following disclaimer           */
/*    in the documentation and/or other materials provided with              */
/*    the distribution.                                                      */
/*                                                                           */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS       */
/* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,                 */
/* BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND         */
/* FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL        */
/* THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,   */
/* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES  (INCLUDING,     */
/* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;          */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER          */
/* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT        */
/* LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN         */
/* ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE           */
/* POSSIBILITY OF SUCH DAMAGE.                                               */


#if (defined(__STDC_VERSION__))
#if __STDC_VERSION__ >= 199901L
#define	C99_INT_TYPES
#include <stdint.h>
#include <stdbool.h>
#endif /* __STDC_VERSION__ >= 199901L */
#endif /* (defined(__STDC_VERSION__)) */

#if (!defined(C99_INT_TYPES))
#if (defined(__GNUC__))
#define	C99_INT_TYPES
#include <stdint.h>
#include <stdbool.h>
#endif /* (defined(__GNUC__)) */
#endif /* (defined(__STDC_VERSION__)) */

#if (!defined(C99_INT_TYPES))
#if (defined(_MSC_VER))
#define	C99_INT_TYPES
#include <stdint.h>
#include <stdbool.h>
#include <BaseTsd.h>
typedef SSIZE_T	ssize_t;
#endif /* (defined(_MSC_VER)) */
#endif /* (defined(__STDC_VERSION__)) */

#if (!defined(C99_INT_TYPES))
#if (defined(__WATCOMC__))
#define	C99_INT_TYPES
#include <stdint.h>
#include <stdbool.h>
#include <BaseTsd.h>
typedef SSIZE_T	ssize_t;
#endif /* (defined(_MSC_VER)) */
#endif /* (defined(__STDC_VERSION__)) */


#if (defined(__GNUC__))
#define	PACKED	__attribute__((packed))
#define RESTRICT __restrict
#endif /* (defined(__GNUC__)) */

#if (!defined(RESTRICT))
#if (defined(_MSC_VER)) || (defined(__BORLANDC__)) || (defined(__WATCOMC__))
#define RESTRICT __restrict
#endif /* (defined(_MSC_VER) || (defined(__BORLANDC__)) || (defined(__WATCOMC__)) */
#endif /* (!defined(RESTRICT)) */

#if (!defined(PACKED))
#define	PACKED
#endif /* (!defined(PACKED)) */

#if (!defined(RESTRICT))
#define RESTRICT
#endif /* (!defined(RESTRICT)) */

#if (!defined(offsetof))
#define	offsetof(stype, member) (uintptr_t)&(((stype *)0)->member)
#endif /* (!defined(offsetof)) */

#if ((!defined(C99_INT_TYPES)) && \
	(   (defined(__BORLANDC__)) \
	 || (defined(__TURBOC__))   \
	 || (defined(LSI_C)) \
	) \
)
#define	C99_INT_TYPES
#define	false		(0)
#define	true		(1)
typedef int		bool;
typedef unsigned char 	uint8_t;
typedef	signed char	int8_t;
typedef	unsigned short	uint16_t;
typedef	short		int16_t;
typedef	unsigned long	uint32_t;
typedef	long		int32_t;
typedef	long		int32x2_t[2];
typedef	int32x2_t	int64_t;	/*!< todo: Implement accessor. */
#endif

#if ((!defined(C99_INT_TYPES)) && (defined(_MSDOS)))
#define	C99_INT_TYPES
#define	false		(0)
#define	true		(1)
typedef int		bool;
typedef unsigned char 	uint8_t;
typedef	signed char	int8_t;
typedef	unsigned short	uint16_t;
typedef	short		int16_t;
typedef	unsigned long	uint32_t;
typedef	long		int32_t;
typedef	long		int32x2_t[2];
typedef	int32x2_t	int64_t;	/*!< todo: Implement accessor. */
#endif

#define cast_bool(b)	((b) != 0)

#if defined(__MSDOS__) || defined(_Windows) || defined(__WINDOWS__) || defined(__WIN32__) || defined(_WIN32) || defined(__WIN64__) || defined(_WIN64) || defined(_MSC_VER)
#define	PATH_CONVENTION_WINDOWS
#else
#define	PATH_CONVENTION_POSIX
#endif
